<template>
  <div class="row justify-content-around">
    <h3 v-html="buildingName"></h3>
    <div class="col-12">
      <h5>Even</h5>
      <SheduleGrid
        :sheduleData="propShedule.even"
        v-model:shedule="shedule.even"
      />
    </div>
    <div class="col-12">
      <h5>Oneven</h5>
      <SheduleGrid
        :sheduleData="propShedule.odd"
        v-model:shedule="shedule.odd"
      />
    </div>
    <button
      type="button"
      @click="convertShedule(shedule)"
      class="col-md-3 border-radius p-1"
    >
      Aanpassen
    </button>
  </div>
</template>

<script>
import SheduleGrid from "./SheduleGrid.vue";
import axios from "axios";

export default {
  components: { SheduleGrid },
  props: {
    buildingName: String,
    buildingObject: Object,
    buildingShedule: Object,
  },
  data() {
    return {
      shedule: { odd: [], even: [] },
      days: [
        { short: "Ma", long: "Maandag" },
        { short: "Di", long: "Dinsdag" },
        { short: "Wo", long: "Woensdag" },
        { short: "Do", long: "Donderdag" },
        { short: "Vr", long: "Vrijdag" },
      ],
      options: [
        { name: "/", value: 0 },
        { name: "restafval", value: 1 },
        { name: "PMD", value: 2 },
        { name: "papier", value: 3 },
        { name: "GFT", value: 4 },
        { name: "glas", value: 5 },
      ],
      updated: {
        even: {
          0: [],
          1: [],
          2: [],
          3: [],
          4: [],
        },
        odd: {
          0: [],
          1: [],
          2: [],
          3: [],
          4: [],
        },
      },
    };
  },
  emits: ["update:updatedShedule"],

  computed: {
    propShedule() {
      // Compute a value based on the prop
      return this.buildingShedule;
    },
  },
  methods: {
    convertShedule(shed) {
      for (const key in shed.even) {
        const values = shed.even[key];

        this.updated.even[key] = [];
        values.forEach((value) => {
          if (value.type != "empty") {
            this.updated.even[key].push({ type: value.type });
          }
        });
      }

      for (const key in shed.odd) {
        const values = shed.odd[key];
        this.updated.odd[key] = [];
        values.forEach((value) => {
          if (value.type != "empty") {
            this.updated.odd[key].push({ type: value.type });
          }
        });
      }
      this.postUpdatedSchedule();
      this.$emit("update:updatedShedule", JSON.stringify(this.updated));
    },
    async postUpdatedSchedule() {
      const buildingData = {
        id: this.buildingObject.id,
        name: this.buildingObject.name,
        roundId: this.buildingObject.round.id,
        imageId: this.buildingObject.imageId,
        address: this.buildingObject.address,
        description: this.buildingObject.description,
        codes: this.buildingObject.codes,
        city: this.buildingObject.city,
        zip: this.buildingObject.zip,
        lat: this.buildingObject.lat,
        lon: this.buildingObject.lon,
        instructionsString: this.buildingObject.instructionsString,
        scheduleString: JSON.stringify(this.updated),
      };

      await axios
        .put(
          "/api/building",
          buildingData, // the data to post
          {
            withCredentials: true,
            headers: {
              "Access-Control-Allow-Origin": "*",
              "Content-Type": "application/json",
            },
          }
        )
        .then((response) => {
          console.log(response);
        });
    },
  },
};
</script>
<style lang="scss" scoped>
@import "../../assets/css/base.css";
@import "../../assets/css/colors.css";
</style>
